/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_HOST_H
#define _UDM_HOST_H

#define UDM_DNSCACHE_TIMEOUT 3600

udm_rc_t UdmHostLookup2(UDM_AGENT *,UDM_HOSTLIST *,UDM_CONN *);
udm_rc_t UdmHostLookupEx(UDM_AGENT *, UDM_HOSTLIST *, UDM_CONN *, int dsn_cache_timeout);
void UdmHostListFree(UDM_HOSTLIST *);
void UdmHostErrorReset(UDM_AGENT *, UDM_HOSTLIST *, const char *hostname);
void UdmHostErrorIncrement(UDM_AGENT *, UDM_HOSTLIST *, const char *hostname);

void UdmInAddrInit(UDM_INADDR *Item);
void UdmInAddrListInit(UDM_INADDRLIST *List);
udm_rc_t UdmInAddrListAdd(UDM_INADDRLIST *List, const UDM_INADDR *Item);
UDM_INADDR *UdmInAddrListFind(UDM_INADDRLIST *List, struct in_addr addr);
void UdmInAddrListFree(UDM_INADDRLIST *List);

#endif
