/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_HREFS_H
#define _UDM_HREFS_H


UDM_API(void) UdmHrefListInit(UDM_HREFLIST *Hrefs);
UDM_API(void) UdmHrefListFree(UDM_HREFLIST * HList);
UDM_API(udm_rc_t) UdmHrefListAdd(UDM_HREFLIST *HList, const UDM_HREF *Href);

udm_rc_t UdmHrefListAddConst(UDM_HREFLIST *L,
                             const UDM_HREFPARAM *T,
                             const char *href);
udm_rc_t UdmHrefListAddConstStr(UDM_HREFLIST *L,
                                const UDM_HREFPARAM *T,
                                const UDM_CONST_STR *href);
udm_rc_t UdmHrefListAddConstStrSGMLUnescape(UDM_HREFLIST *L,
                                            const UDM_HREFPARAM *T,
                                            const UDM_VARLIST *Vars,
                                            const UDM_CONST_STR *href);

void UdmHrefParamInit(UDM_HREFPARAM *HrefParam);
void UdmHrefInit(UDM_HREF *Href);
void UdmHrefFree(UDM_HREF *Href);

const char *UdmLinkSourceStr(udm_link_source_t link_source);
udm_link_source_t UdmLinkSourceByName(const char *name);

#endif
