/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef _UDM_MUTEX_H
#define _UDM_MUTEX_H

/* TODO34: move the declarations inside mutex.c */
#ifdef WIN32
typedef HANDLE udm_thread_t;
#else
#ifdef HAVE_PTHREAD
#include <pthread.h>
typedef pthread_t udm_thread_t;
#else
typedef int udm_thread_t;
#endif
#endif

#ifdef WIN32
typedef unsigned (__stdcall *udm_thread_routine_t)(void*);
#else
typedef void *(*udm_thread_routine_t)(void*);
#endif


/* MUTEX stuff to lock dangerous places in multi-threaded mode */

UDM_API(void) UdmLockProc(UDM_AGENT *A,
                          udm_mutexcmd_t command,
                          udm_mutexno_t number,
                          const char *file, int lineno);

UDM_API(void) UdmInitMutexes(void);
UDM_API(void) UdmDestroyMutexes(void);
size_t UdmMutexNamePrint(char *str, size_t length, udm_mutexno_t id);
size_t UdmMutexStatePrint(char *str, size_t length, UDM_AGENT *A, udm_mutexno_t id);

UDM_API(udm_rc_t) UdmThreadCreate(void *thd, udm_thread_routine_t start_routine, void *arg);
UDM_API(udm_rc_t) UdmThreadJoin(void *thd);

#ifdef WIN32
/*__C_LINK udm_mutex_t ThreadProcLock;*/
#endif

#endif /* _UDM_MUTEX_H */
