/* Copyright (C) 2000-2015 Lavtech.com corp. All rights reserved.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA 
*/

#ifndef UDM_UNIDATA_H
#define UDM_UNIDATA_H

/* Character types */
#define UDM_UNI_SEPAR	0
#define UDM_UNI_LETTER	1
#define UDM_UNI_DIGIT	2
#define UDM_UNI_CJK	3
#define UDM_UNI_MAX	3

struct udm_unidata_st;
typedef const struct udm_unidata_st UDM_UNIDATA;
extern UDM_UNIDATA *udm_unidata_default;
extern UDM_UNIDATA *udm_unidata_turkish;


int  UdmUniIsSpace(int uni);
int  UdmUniToLower(UDM_UNIDATA *, int uni);
UDM_API(void) UdmUniStrToLower(UDM_UNIDATA *, int * unistr);
void UdmUniStrStripAccents(UDM_UNIDATA *, int *unistr);
int  UdmUniCType(UDM_UNIDATA *, int u);
size_t UdmStrToLowerExt(UDM_UNIDATA *, UDM_CONV *cnv,
                        char *dst, size_t dstsize,
                        const char *src, size_t srclen, int flags);
void UdmStrToLower(UDM_UNIDATA *, UDM_CHARSET *cs,
                   char *str, size_t bytelen);
void UdmStrToLower8bit(UDM_UNIDATA *, UDM_CHARSET *cs,
                       char *str, size_t bytelen);

int *UdmUniGetToken(UDM_UNIDATA *, int * s, int ** last);
int *UdmUniGetSepToken(UDM_UNIDATA *,
                       int *str, int *strend,
                       int **last, int *ctype0);
int *UdmUniGetSepToken2(UDM_UNIDATA *,
                        int *str, int *strend,
                        int **last, int *ctype0);

int UdmStrCaseCmp2(UDM_UNIDATA *, UDM_CONV *conv,
                   const char *s, size_t slen,
                   const char *t, size_t tlen,
                   int flags);
                          
int UdmStrCaseAccentCmp2(UDM_UNIDATA *, UDM_CONV *conv,
                         const char *s, size_t slen,
                         const char *t, size_t tlen,
                         int flags);

int UdmUniStrNCaseCmp(UDM_UNIDATA *,
                      const int *s1, const int *s2, size_t len);

int UdmAutoPhraseChar(int ch);

void UdmSoundex(UDM_CHARSET *cs, char *dst, size_t dstlen,
                const char *src, size_t srclen);

UDM_UNIDATA *UdmUnidataGetByName(const char *name);

udmcrc32_t UdmCRC32LCase8bit(UDM_UNIDATA *unidata, UDM_CHARSET *cs,
                                    const char *src, size_t srclen,
                                    int flags);
udmcrc32_t UdmCRC32LCaseGeneric(UDM_UNIDATA *unidata, UDM_CHARSET *cs,
                                       const char *src, size_t srclen,
                                       int flags);

int UdmGetWordMB(UDM_WORD_SCANNER *scanner, UDM_WORD_SCANNER_TOKEN *str);

#endif
